tile = {}
map = {}
map_methods = {}

function tile:new(x,y)
	obj = {
		x = x,
		y = y
	}
	setmetatable(obj, tile)
	self.__index = self
	return obj
end

function tile:draw()
	if self.collide then
		gr.rectangle("fill", self.x, self.y, 32, 32)
	else
		gr.rectangle("line", self.x, self.y, 32, 32)
	end
end

function map_methods:clear()
	for i = 1, #map do
		table.remove(map)
	end
end

function map_methods:create()
	map_methods:clear()
	local i, j
	i = 0
	j = 0
	for y = 1, 22 do
		map[y] = {}
		if y == 1 then
		else
			j = j + 32
			i = 0
		end
		for x = 1, 33 do
			map[y][x] = tile:new(x+i, y+j)
			i = i + 32
		end
	end
end

function map_methods:update(dt)
	
end

function map_methods:draw()
	gr.setColor(255, 255, 255, 255)
	for i = 1, #map do
		for j = 1, #map[i] do
			map[i][j]:draw()
		end
	end
end

function map_methods:mousepress(x, y, button)
	if button == "l" then
		for i = 1, #map do
			for j = 1, #map[i] do
				if boxCollision(x, y, 1, 1, map[i][j].x, map[i][j].y, 32, 32) then
					map[i][j].collide = not map[i][j].collide
				end
			end
		end
	elseif button == "r" then
        pathfind:generateNodes() -- I ADDED THIS
        pathfind:calculate({x=x,y=y}) -- I ADDED THIS
	end
end

function map_methods:keyboard(key, unicode)
	if key == "f1" then
		map_methods:create()
	elseif key == "f2" then
		map_methods:clear()
	end
end