pathfind = {}
nodes = {}

path = nil

function pathfind:generateNodes()
    nodes = {}
    for i = 1, #map do
		for j = 1, #map[i] do
			if not map[i][j].collide then
				table.insert(nodes, { x=map[i][j].x + 16, y=map[i][j].y + 16 })
			end
		end
	end
end

function pathfind:drawNodes()
	gr.setColor(0, 0, 255, 255)
	for i = 1, #nodes do
        gr.point(nodes[i].x, nodes[i].y)
	end
end

function pathfind:drawPath()
    if path ~= nil then
        for i,node in pairs(path) do
            gr.circle("fill", node.x, node.y, 16, 16)
        end
    end
end

-- a node is a valid neighbor if he is close enough
local function nodeIsValidNeighbor(node, neighbor)
    
    local DIST = 40 -- change this to affect path finding

    -- helper function in the a-star module, returns distance between points
    return astar.distance ( node.x, node.y, neighbor.x, neighbor.y ) < DIST

end


-- use astar library to calculate path.
function pathfind:calculate(goal)
    
    path = nil
    
    local startnode = nil -- we start here
    local endnode = nil -- we end here
    
    -- find nodes that are closest to player and goal
    for i,node in pairs(nodes) do
        if node.x <= player.x + 16 and player.x + 16 < node.x + 48 and node.y <= player.y + 16 and player.y + 16 < node.y + 48 then 
            startnode = node 
        end
        if node.x <= goal.x and goal.x <= node.x + 32 and node.y <= goal.y and goal.y <= node.y + 32 then 
            endnode = node 
        end
    end
    
    if startnode == nil then print( "error calculating start node. Aborting path find") return end
    if endnode == nil then print( "error calculating end node. Aborting path find") return end
    
    path = astar.path ( startnode, endnode, nodes, true, nodeIsValidNeighbor )
    
    if path then
        print("Valid path found")
    else
        print( "No path found")
    end

end

function pathfind:keypressed(key, uni)

end